--- July/Aug 2021
	
-- S-3B Recovery Tanker.
-- Tanker Shell
local tanker=RECOVERYTANKER:New( "TDR", "Tanker TDR" )
  tanker:SetTakeoffHot()
  tanker:SetRadio(244)
  tanker:SetModex(511)
  tanker:SetTACAN(44, "SHL")
  tanker:__Start(1)	

-- Rescue Helo
local rescuehelo=RESCUEHELO:New( "TDR", "Rescue Heli")
rescuehelo:SetModex(42)
rescuehelo:SetRescueOn()
rescuehelo:SetRescueZone(10)
rescuehelo:__Start(1)


local airbossAbe=AIRBOSS:New("TDR", "USS Teddy Roosevelt")
airbossAbe:SetSoundfilesFolder("Airboss Soundfiles/")
-- radio
airbossAbe:SetRadioRelayLSO("LSO Radio") -- 264 FM
airbossAbe:SetRadioRelayMarshal("Marshal Radio") -- 305 FM
airbossAbe:SetLSORadio(264,"AM")
airbossAbe:SetMarshalRadio(305,"AM")
airbossAbe:SetDefaultPlayerSkill("Naval Aviator")
airbossAbe:SetTACAN(71,"X","TDR")
airbossAbe:SetICLS(1,"TDR")
airbossAbe.skipperMenu = true
airbossAbe:SetAirbossNiceGuy(true)

airbossAbe:SetMenuSingleCarrier(true)

airbossAbe:Start()

Spawn_Awacs = SPAWN
 :New( "Blue Awacs" )
 :InitLimit( 1, 0 )
 --:InitRepeatOnLanding()
 :InitCleanUp( 300 )
 :InitRadioCommsOnOff(true)
 :InitRadioFrequency(271)
 :InitRadioModulation("AM")
 :OnSpawnGroup(
 function ( awacs ) 
    awacs:CommandSetFrequency( 271 )
    awacs:CommandSetCallsign(CALLSIGN.AWACS.Focus,1,1)
 end
 )
 :SpawnScheduled( 600, 0.2 )
 

BASE:I("Airboss Setup Done")

-- Blue GCI CVN Ops Caucasus map
BASE:I("Blue CVN CAP Starting")


-- Define a SET_GROUP object that builds a collection of groups that define the EWR network.
-- Here we build the network with all the groups that have a name starting with DF CCCP AWACS and DF CCCP EWR.
Blue_DetectionSetGroup = SET_GROUP:New()
Blue_DetectionSetGroup:FilterPrefixes( { "CVN-71" } )
Blue_DetectionSetGroup:FilterOnce()

Blue_Detection = DETECTION_AREAS:New( Blue_DetectionSetGroup, 30000 )

-- Setup the A2A dispatcher, and initialize it.
Blue_A2ADispatcher = AI_A2A_DISPATCHER:New( Blue_Detection )

-- Setup the border zone. 
-- In this case the border is a zone surrounding the carrier
-- Any enemy crossing this border will be engaged.
Blue_BorderZone = ZONE_UNIT:New("CVN Zone",UNIT:FindByName("TDR"),100000)
Blue_A2ADispatcher:SetBorderZone( Blue_BorderZone )

Blue_A2ADispatcher:SetTacticalDisplay( false )

--TDRTanker = rectanker.tanker.GroupName
--m = MESSAGE:New(string.format("Recover Tanker Group Name is: %s", TDRTanker),10,"Info"):ToAll()

Blue_A2ADispatcher:SetDefaultCapLimit(2)
--Blue_A2ADispatcher:SetDefaultTanker( TDRTanker )
Blue_A2ADispatcher:SetDefaultFuelThreshold(0.3)
Blue_A2ADispatcher:SetDefaultLandingAtEngineShutdown()
Blue_A2ADispatcher:SetDefaultTakeoffFromParkingHot()
Blue_A2ADispatcher:SetSquadron( "CVN-71", "TDR", "Blue Knights" )
--Blue_A2ADispatcher:SetSquadronTanker("CVN-71", TDRTanker)
Blue_A2ADispatcher:SetSquadronCap( "CVN-71", Blue_BorderZone, UTILS.FeetToMeters(15000), UTILS.FeetToMeters(30000) , UTILS.KnotsToKmph(300),UTILS.KnotsToKmph(400), UTILS.KnotsToKmph(600), UTILS.KnotsToKmph(800), "BARO")
Blue_A2ADispatcher:SetSquadronLandingNearAirbase("CVN-71")
Blue_A2ADispatcher:SetSquadronCapRacetrack("CVN-71", 10000, 15000, 90, 270)
Blue_A2ADispatcher:SetIntercept( 30 )
Blue_A2ADispatcher:SetDisengageRadius( 100000 )
Blue_A2ADispatcher:SetEngageRadius( 75000 )
Blue_A2ADispatcher:SetGciRadius( 125000 )
Blue_A2ADispatcher:SetDefaultOverhead( 0.5 )
Blue_A2ADispatcher:Start()

BASE:I("Blue CVN CAP Started")

