--
BASE:I("Air Support Starting")

BlueCASCurrAuftrag = nil
BlueCAPCurrAuftrag = nil
BlueSEADCurrAuftrag = nil

local CASZones = {}
CASZones[1] = "Move Bandar"
CASZones[2] = "Move Bandar"
CASZones[3] = "Pickup Berlin"
CASZones[4] = "Pickup Madrid"
CASZones[5] = "Move Seerik"

local awkhasab = AIRWING:New("Warehouse Khasab-1","111th Expedition Corps")
awkhasab:SetAirbase(AIRBASE:FindByName(AIRBASE.PersianGulf.Khasab))
awkhasab:SetRespawnAfterDestroyed(300)
awkhasab:SetReportOff()
awkhasab:SetMarker(false)

local BorderZone = ZONE_POLYGON:New( "Rus Border", GROUP:FindByName( "Red Border" ) )
local nogoset = SET_ZONE:New()
nogoset:AddZone(BorderZone)

function awkhasab:OnAfterFlightOnMission(From, Event, To, Flightgroup, Mission)
  local flightgroup = Flightgroup -- Ops.FlightGroup#FLIGHTGROUP
  flightgroup:SetDespawnAfterLanding()
  flightgroup:SetDestinationbase(AIRBASE:FindByName(AIRBASE.Syria.Rene_Mouawad))
  flightgroup:GetGroup():CommandEPLRS(true,5)
  flightgroup:SetEngageDetectedOn(25,{"Air"},nil,nogoset)
  
  function flightgroup:OnAfterHolding(From,Event,To)
    self:ClearToLand(5)
  end 
  
end

awkhasab:Start()

local capone = SQUADRON:New("Blue CAP",6,"AdA Jeanne")
capone:AddMissionCapability({AUFTRAG.Type.CAP, AUFTRAG.Type.GCICAP, AUFTRAG.Type.INTERCEPT})
capone:SetFuelLowRefuel(true)
capone:SetFuelLowThreshold(0.3)
capone:SetTurnoverTime(10,20)
capone:SetRadio(271,0)

awkhasab:AddSquadron(capone)
awkhasab:NewPayload("Blue CAP",-1,{AUFTRAG.Type.CAP, AUFTRAG.Type.GCICAP, AUFTRAG.Type.INTERCEPT},75)

local captwo = SQUADRON:New("Blue CAP 1",6,"JgdG Boelcke")
captwo:AddMissionCapability({AUFTRAG.Type.CAP, AUFTRAG.Type.GCICAP, AUFTRAG.Type.INTERCEPT})
captwo:SetFuelLowRefuel(true)
captwo:SetFuelLowThreshold(0.3)
captwo:SetTurnoverTime(10,20)
captwo:SetRadio(271,0)

awkhasab:AddSquadron(captwo)
awkhasab:NewPayload("Blue CAP 1",-1,{AUFTRAG.Type.CAP, AUFTRAG.Type.GCICAP, AUFTRAG.Type.INTERCEPT},70)

local capthree = SQUADRON:New("Blue CAP 2",6,"5th Stormo")
capthree:AddMissionCapability({AUFTRAG.Type.CAP, AUFTRAG.Type.GCICAP, AUFTRAG.Type.INTERCEPT})
capthree:SetFuelLowRefuel(true)
capthree:SetFuelLowThreshold(0.3)
capthree:SetTurnoverTime(10,20)
capthree:SetRadio(271,0)

awkhasab:AddSquadron(capthree)
awkhasab:NewPayload("Blue CAP 2",-1,{AUFTRAG.Type.CAP, AUFTRAG.Type.GCICAP, AUFTRAG.Type.INTERCEPT},75)

local casone = SQUADRON:New("Blue CAS",6,"JaBoG 72")
casone:AddMissionCapability({AUFTRAG.Type.CAS, AUFTRAG.Type.BAI, AUFTRAG.Type.SEAD, AUFTRAG.Type.BOMBING})
casone:SetFuelLowRefuel(true)
casone:SetFuelLowThreshold(0.3)
casone:SetTurnoverTime(10,20)
casone:SetRadio(271,0)

awkhasab:AddSquadron(casone)
awkhasab:NewPayload("Blue CAS",-1,{AUFTRAG.Type.CAS, AUFTRAG.Type.BAI, AUFTRAG.Type.SEAD, AUFTRAG.Type.BOMBING},76)

local castwo = SQUADRON:New("Blue CAS 1",6,"82nd AFW")
castwo:AddMissionCapability({AUFTRAG.Type.CAS, AUFTRAG.Type.BAI, AUFTRAG.Type.SEAD, AUFTRAG.Type.BOMBING})
castwo:SetFuelLowRefuel(true)
castwo:SetFuelLowThreshold(0.3)
castwo:SetTurnoverTime(10,20)
castwo:SetRadio(271,0)

awkhasab:AddSquadron(castwo)
awkhasab:NewPayload("Blue CAS 1",-1,{AUFTRAG.Type.CAS, AUFTRAG.Type.BAI, AUFTRAG.Type.SEAD, AUFTRAG.Type.BOMBING},75)

local casthree = SQUADRON:New("Blue CAS 2",2,"5th Stormo GA")
casthree:AddMissionCapability({AUFTRAG.Type.CAS, AUFTRAG.Type.BAI, AUFTRAG.Type.SEAD, AUFTRAG.Type.BOMBING})
casthree:SetFuelLowRefuel(true)
casthree:SetFuelLowThreshold(0.3)
casthree:SetTurnoverTime(10,20)
casthree:SetRadio(271,0)

awkhasab:AddSquadron(casthree)
awkhasab:NewPayload("Blue CAS 2",-1,{AUFTRAG.Type.CAS, AUFTRAG.Type.BAI, AUFTRAG.Type.SEAD, AUFTRAG.Type.BOMBING},77)

function Blue_Cas(AuftragMission)

   local RandomCAS = {
      [1] = "Blue CAS",
      [2] = "Blue CAS 1",
      [3] = "Blue CAS 2", 
    }
    local RandomPlane = RandomCAS[math.random(#RandomCAS)]
    local RandomCAS = "Blue CAS"
    local CASSpawnTemplate = SPAWN:NewWithAlias(RandomPlane, RandomCAS .. math.random(1, 100000))
    local CASGroup = CASSpawnTemplate:Spawn()
    local FlightGroup = FLIGHTGROUP:New(CASGroup)
    local HomeAirbase = AIRBASE:FindByName(AIRBASE.PersianGulf.Khasab)
    FlightGroup:SetFuelLowRTB(true)
    FlightGroup:SetDespawnAfterLanding()
    FlightGroup:SetHomebase(HomeAirbase)
    FlightGroup:GetGroup():CommandEPLRS(true)
    FlightGroup:SetEngageDetectedOn(10,{"Ground"})
    FlightGroup:AddMission(AuftragMission)
    
    function FlightGroup:OnAfterHolding(From,Event,To)
      self:ClearToLand(5)
    end
end

function Blue_Cap(AuftragMission)
    local RandomCAP = {
      [1] = "Blue CAP",
      [2] = "Blue CAP 1",
      [3] = "Blue CAP 2", 
    }
    local RandomPlane = RandomCAP[math.random(#RandomCAP)]
    local CAPSpawnTemplate = SPAWN:NewWithAlias(RandomPlane, "Blue CAP" .. math.random(1, 100000))
    local CAPGroup = CAPSpawnTemplate:Spawn()
    local FlightGroup = FLIGHTGROUP:New(CAPGroup)
    local HomeAirbase = AIRBASE:FindByName(AIRBASE.PersianGulf.Khasab)
    FlightGroup:SetFuelLowRTB(true)
    FlightGroup:SetDespawnAfterLanding()
    FlightGroup:SetHomebase(HomeAirbase)
    FlightGroup:GetGroup():CommandEPLRS(true)
    FlightGroup:SetEngageDetectedOn(30,{"Air"})
    FlightGroup:AddMission(AuftragMission)
    
    function FlightGroup:OnAfterHolding(From,Event,To)
      self:ClearToLand(5)
    end
end

function Blue_CAS_Auftrag()
  local TgtZone = ZONE:New(CASZones[CurrentTask])
  local zonename = TgtZone:GetName()
  local ZoneCASCoord = TgtZone:GetCoordinate()
  local CASAUFTRAG = AUFTRAG:NewCAS(TgtZone,30000,UTILS.KnotsToAltKIAS(300,30000),nil,0,15)
  CASAUFTRAG:SetRequiredAssets(2)
  BlueCASCurrAuftrag = CASAUFTRAG
  awkhasab:AddMission(CASAUFTRAG)
  BASE:I("***** Blue CAS Requested *****")
  local m = MESSAGE:New(string.format("Blue CAS starting for %s.",zonename),15,"CAS"):ToBlue()
  RadioBroadcast("Air_Support")
end

function Blue_CAP_Auftrag()
  local zone = 1
  local ZoneCAP = ZONE:New(CASZones[CurrentTask])
  local zonename = ZoneCAP:GetName()
  local ZoneCAPCoord = ZoneCAP:GetCoordinate()
  local CAPAUFTRAG = AUFTRAG:NewCAP(ZoneCAP,35000,UTILS.KnotsToAltKIAS(300,30000),nil,90,20)
  CAPAUFTRAG:SetRequiredAssets(2)
  BlueCAPCurrAuftrag = CAPAUFTRAG
  awkhasab:AddMission(CAPAUFTRAG)

  BASE:I("***** Blue CAP Requested *****")
  local m = MESSAGE:New(string.format("Blue CAP starting for %s.",zonename),15,"CAP"):ToBlue()
  RadioBroadcast("Air_Support")
end


local SEADGroups = SET_GROUP:New():FilterActive(true):FilterPrefixes({"Red SAM","Insurgents"}):FilterCoalitions("red"):FilterStart()

function Blue_SEAD_Auftrag()

  local SEADNAME = {
    [1] = "SAM Bandar",
    [2] = "SAM Bandar",
    [3] = "Berlin",
    [4] = "Madrid",
    [5] = "SAM Seerik",
  }
  
  local Targets = SEADGroups:GetSetObjects()
  local SEADTarget = nil
  local tomatch = SEADNAME[CurrentTask]
  local match = false
  for _,_grp in pairs(Targets) do
    local group = _grp -- Wrapper.Group#GROUP
    local name = group:GetName()
    if string.find(name,tomatch) then
      SEADTarget = group
      match = true
      break
    end
  end
  
  if match and SEADTarget and SEADTarget:IsAlive() then
    local CAPAUFTRAG = AUFTRAG:NewSEAD(SEADTarget,31000)
    CAPAUFTRAG:SetRequiredAssets(2)
    BlueSEADCurrAuftrag = CAPAUFTRAG
    awkhasab:AddMission(CAPAUFTRAG)
    BASE:I("***** Blue SEAD Requested *****")
    local m = MESSAGE:New(string.format("Blue SEAD starting!"),15,"SEAD"):ToBlue()
    RadioBroadcast("Air_Support")
  else
    local m = MESSAGE:New(string.format("No SEAD target detected for this stage!"),15,"SEAD"):ToBlue()
  end
  
end

function Blue_CAS_Request()
  if not BlueCASCurrAuftrag then
    -- nothing yet
    Blue_CAS_Auftrag()
  else
    if BlueCASCurrAuftrag:IsNotOver() then
      -- Auftrag still ongoing
      local m = MESSAGE:New("Blue CAS is in the air.",15,"CAS"):ToBlue()
    else
      -- need a new one
      Blue_CAS_Auftrag()
    end
  end
end

function Blue_CAP_Request()
  if not BlueCAPCurrAuftrag then
    -- nothing yet
    Blue_CAP_Auftrag()
  else
    if BlueCAPCurrAuftrag:IsNotOver() then
      -- Auftrag still ongoing
      local m = MESSAGE:New("Blue CAP is in the air.",15,"CAP"):ToBlue()
    else
      -- need a new one
      Blue_CAP_Auftrag()
    end
  end
end

function Blue_SEAD_Request()
  if not BlueSEADCurrAuftrag then
    -- nothing yet
    Blue_SEAD_Auftrag()
  else
    if BlueSEADCurrAuftrag:IsNotOver() then
      -- Auftrag still ongoing
      local m = MESSAGE:New("Blue CAP is in the air.",15,"CAP"):ToBlue()
    else
      -- need a new one
      Blue_SEAD_Auftrag()
    end
  end
end

MenuCASBlue = MENU_COALITION:New( coalition.side.BLUE,"Request Air Support")
MenuCASBlue1 = MENU_COALITION_COMMAND:New(coalition.side.BLUE,"Request CAS", MenuCASBlue, Blue_CAS_Request)
MenuCASBlue2 = MENU_COALITION_COMMAND:New(coalition.side.BLUE,"Request CAP", MenuCASBlue, Blue_CAP_Request)
MenuCASBlue3 = MENU_COALITION_COMMAND:New(coalition.side.BLUE,"Request SEAD", MenuCASBlue, Blue_SEAD_Request):Refresh()

BASE:I("Air Support Ended")