---
BASE:I("Airlift Starting")

function AirLiftGo()

  local SetCargoInfantry = SET_CARGO:New():FilterTypes( {"Humvee","Infantry"} ):FilterStart()
  local SetHelicopter = SET_GROUP:New():FilterPrefixes( "Navy Helicopter" ):FilterStart()
  local SetPickupZones = SET_ZONE:New():FilterPrefixes( "Pickup Location" ):FilterStart()
  local SetDeployZones = SET_ZONE:New():FilterPrefixes( "Defense" ):FilterStart()
  
  AICargoDispatcherHelicopter = AI_CARGO_DISPATCHER_HELICOPTER:New( SetHelicopter, SetCargoInfantry, SetPickupZones, SetDeployZones ) 
  AICargoDispatcherHelicopter:SetHomeZone( ZONE:FindByName( "Home" ) )
  
  -- Now we create 4 zones based on GROUP objects within the battlefield, which form the front line defense points.
  local ZoneDefense1 = ZONE:New( "Defense 1" )
  local ZoneDefense2 = ZONE:New( "Defense 2" )
  local ZoneDefense3 = ZONE:New( "Defense 3" )
  local ZoneDefense4 = ZONE:New( "Defense 4" )
  
  function AICargoDispatcherHelicopter:OnAfterUnloaded(From,Event,To,CarrierGroup,Cargo,CarrierUnit,DeployZone)
    local cargo = Cargo -- Cargo.Cargo#CARGO
    local Group = cargo:GetObject() -- Wrapper.Group#GROUP
    local zone = ZONE:New("Move Seerik")
    local coord = zone:GetRandomCoordinate()
    Group:RouteGroundTo(coord,30,"Vee",5)
  end
  
  AICargoDispatcherHelicopter:SetPickupRadius( 75, 25)
  AICargoDispatcherHelicopter:SetDeployRadius( 200, 100 )
  AICargoDispatcherHelicopter:SetPickupSpeed( 300, 200 )
  AICargoDispatcherHelicopter:SetDeploySpeed( 300, 200 )
  AICargoDispatcherHelicopter:SetPickupHeight( 75, 20 )
  AICargoDispatcherHelicopter:SetDeployHeight( 75, 20 )
  
  AICargoDispatcherHelicopter:__Start( 10 )

end

local helipilothelis = SET_CLIENT:New():FilterCoalitions("blue"):FilterActive():FilterCategories("helicopter"):FilterStart()
local helilifton = false

local SpawnCargoInfantry2 = {}
function CheckHeliLift()
  local alivecount = helipilothelis:CountAlive()
  if CurrentTask > 4 and alivecount > 0 and not helilifton then
    AirLiftGo()
    helilifton = true
      -- Here we setup the spawning of Humvees.
    SpawnCargoInfantry2[#SpawnCargoInfantry2+1] = SPAWN
      :NewWithAlias("Humvee","Humvee"..math.random(1,10000))
      :InitLimit( 5, 5 )
      :InitRandomizeZones( { ZONE:New( "Pickup Location" ) } )
      :OnSpawnGroup(
        function( SpawnGroup )
          -- This will automatically add also the CargoInfantry object to the SetCargoInfantry (in the background through the event system).
          local CargoInfantry = CARGO_GROUP:New( SpawnGroup, "Humvee", SpawnGroup:GetName(), 1000 )
        end
      )
      :SpawnScheduled( 300, 0.5 )
      
    SpawnCargoInfantry2[#SpawnCargoInfantry2+1] = SPAWN
      :NewWithAlias("Navy Helicopter","Navy Helicopter-"..math.random(1,10000))
      :InitLimit(4,4)
      :InitDelayOff()
      :InitRandomizeTemplatePrefixes("Navy Transport Heli")
      :SpawnScheduled(300,0.5)
      
    BASE:I("**** Helilift ON")
  elseif CurrentTask > 4 and alivecount == 0 and helilifton then
    AICargoDispatcherHelicopter:__Stop(1)
    helilifton = false
    BASE:I("**** Helilift OFF")
  end
  return
end

local CheckHeliTimer = TIMER:New(CheckHeliLift)
CheckHeliTimer:Start(30,60)

BASE:I("Airlift Ended")