---
BASE:I("CTLD Setup Starting")
-- globals
local codetable = UTILS.GenerateLaserCodes()
local farpactivetime = 300
local crateweight = 500
local soldierweight = 80
local EnableCSAR = true
--CurrentTask = 1

-- CTLD Actions
local StageActions = {}
local ArmyGroups = {}
  
StageActions["Dallas"] = {
      statics = { name = "Static Dallas ", number = 4},
      groups = { {name = "Ground-", number = 6}},
      zones = { name = "Pickup Dallas" },
      message = "FARP Dallas back in operation! Good job!",
      nexttask = 2,
  }
  
StageActions["Berlin"] = {
      statics = { name = "Berlin-", number = 4},
      groups = { {name = "Berlin ATC-", number = 1},},
      zones = { name = "Pickup Berlin" },
      message = "FARP Berlin is back in operation! Good job! Stock added.",
      nexttask = 4,
      }
      
StageActions["Madrid"] = {
      statics = { name = "Madrid-", number = 7},
      groups = { {name = "Madrid ATC-", number = 2}, {name = "Madrid Ammo Truck-", number = 1 }},
      zones = { name = "Pickup Madrid" },
      message = "FARP Madrid is back in operation! Good job! Stock added.",
      nexttask = 5,
      }


-- AUTOLASE
local recceset = SET_GROUP:New():FilterActive():FilterCategoryGround():FilterPrefixes({"LAV","JTAC"}):FilterCoalitions("blue"):FilterStart()
my_autolase = AUTOLASE:New(recceset,coalition.side.BLUE,"Wolfpack",planepilots)
my_autolase:SetLasingParameters(6000,300)

local truckset = SET_GROUP:New():FilterCoalitions("blue"):FilterActive(true):FilterCategoryGround():FilterPrefixes("Ammo Truck"):FilterStart()
local ariset = SET_GROUP:New():FilterCoalitions("blue"):FilterActive(true):FilterCategoryGround():FilterPrefixes("Mortar"):FilterStart()

blueammotruck = AMMOTRUCK:New(truckset,ariset,coalition.side.BLUE,"LgtRg II",ZONE:FindByName("Pickup Dallas"))

-- CTLD
my_ctld = CTLD:New(coalition.side.BLUE,{"Player"},"LogRgt I")
my_ctld.forcehoverload = false
my_ctld.enableHercules = false
my_ctld.dropcratesanywhere = true
my_ctld.debug = false
my_ctld.useprefix = true
my_ctld.maximumHoverHeight = 15
my_ctld.CrateDistance = 40
my_ctld.verbose = 0
my_ctld.smokedistance = UTILS.NMToMeters(3)
my_ctld.placeCratesAhead = false
my_ctld.enableLoadSave = EnableSaving
my_ctld.filename = "CTLD_Bunnyhop.csv"
--my_ctld.filepath = "C:\\Users\\Administrator\\Saved Games\\DCS.openbeta_server_public_2\\persistent-data"
--SavePath = "C:\\Users\\post\\SAVEDG~1\\DCS\\Missions\\Bunnyhop"
my_ctld.filepath = SavePath
my_ctld.pilotmustopendoors = true
my_ctld:__Start(5)

--my_ctld:AddTroopsCargo("Wrenches",{"Engineers"},CTLD_CARGO.Enum.ENGINEERS,4,80,1)
my_ctld:AddCTLDZone("Pickup Engin",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Blue,true,true)
my_ctld:AddCTLDZone("Giant",CTLD.CargoZoneType.SHIP,SMOKECOLOR.Blue,true,true,450,70)
my_ctld:AddCTLDZone("Pickup Dallas",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Green,false,true)
my_ctld:AddCTLDZone("Pickup Berlin",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Green,false,true)
my_ctld:AddCTLDZone("Pickup Madrid",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Green,false,true)
my_ctld:AddCTLDZone("Pickup Bandar",CTLD.CargoZoneType.LOAD,SMOKECOLOR.Green,false,true)

my_ctld:AddCTLDZone("Drop Bandar",CTLD.CargoZoneType.DROP,SMOKECOLOR.Red,true,true)
my_ctld:AddCTLDZone("Move Bandar",CTLD.CargoZoneType.MOVE,SMOKECOLOR.White,true,false)
my_ctld:AddCTLDZone("Move Seerik",CTLD.CargoZoneType.MOVE,SMOKECOLOR.White,true,false)

my_ctld:AddCratesCargo("Humvee TOW",{"Humvee TOW"},CTLD_CARGO.Enum.VEHICLE,1,crateweight,2)
my_ctld:AddCratesCargo("Humvee MG",{"Humvee MG"},CTLD_CARGO.Enum.VEHICLE,1,crateweight,2)
my_ctld:AddCratesCargo("Humvee JTAC",{"Humvee JTAC"},CTLD_CARGO.Enum.VEHICLE,1,crateweight,2)
my_ctld:AddCratesCargo("IFV Bradley",{"Bradley"},CTLD_CARGO.Enum.VEHICLE,4,crateweight,2)
my_ctld:AddCratesCargo("Ammo Truck",{"Ammo Truck"},CTLD_CARGO.Enum.VEHICLE,1,crateweight,nil)

my_ctld:AddTroopsCargo("Infantry Squad (6)",{"Infantry6"},CTLD_CARGO.Enum.TROOPS,6,soldierweight,2)
my_ctld:AddTroopsCargo("Mortar Squad (4)",{"Mortar6"},CTLD_CARGO.Enum.TROOPS,6,soldierweight,2)
my_ctld:AddTroopsCargo("Engineer Group (2)",{"Engineers"},CTLD_CARGO.Enum.ENGINEERS,2,soldierweight,2)
--my_ctld:AddTroopsCargo("Stinger Group (4)",{"Stinger4"},CTLD_CARGO.Enum.TROOPS,4,soldierweight,2)
my_ctld:AddTroopsCargo("Stinger Group (2)",{"Stinger2"},CTLD_CARGO.Enum.TROOPS,2,soldierweight,4)

--my_ctld:AddStaticsCargo("Ammunition",crateweight)
--my_ctld:AddStaticsCargo("Huey Cargo",crateweight)

my_ctld:UnitCapabilities("SA342M", true, true, 1, 4, 12)
my_ctld:UnitCapabilities("SA342Mistral", true, true, 1, 4, 12)
my_ctld:UnitCapabilities("SA342Minigun", true, true, 1, 2, 12)
my_ctld:UnitCapabilities("SA342L", true, true, 1, 4, 12)
my_ctld:UnitCapabilities("Ka-50", true, false, 1, 0, 12)

function FindMortarTargets(Mortar)
  local mortar = Mortar -- Wrapper.Group#GROUP
  local redset = SET_UNIT:New():FilterCoalitions("red"):FilterCategories("ground"):FilterOnce()
  local mortarcoord = mortar:GetCoordinate()
  local foundset = SET_UNIT:New()
  for _,_object in pairs (redset:GetSetObjects()) do
    local redgrp = _object -- Wrapper.Unit#UNIT
    local redcoo = redgrp:GetCoordinate()
    local dist = mortarcoord:Get2DDistance(redcoo)
    if dist <= 7000 then
      --BASE:I("Mortar targets adding: " .. redgrp:GetName())
      foundset:AddObject(redgrp)
    end
  end
  return foundset
end

function my_ctld:OnAfterTroopsDeployed(From,Event,To,Group,Unit,Troops)
  self:__Save(10)
  --local m = MESSAGE:New("Checking FARP Repair",15,"Info"):ToAll()
  local name = Troops:GetName()
  local taskchange = false
  if string.match(name,"Engineer") then
    if CurrentTask == 1 then
      BASE:I("Checking Dallas")
      -- position check
      local zone = ZONE:New("Pickup Dallas")
      local radius = zone:GetRadius()
      local coord = zone:GetCoordinate()
      local coord2 = Troops:GetCoordinate()
      local dist = coord:Get2DDistance(coord2)
      if dist <= radius then
        --BASE:I("Activate Dallas")
        local Task1Sched = TIMER:New(ActivateFARP, "Dallas")
        Task1Sched:Start(farpactivetime)
        CurrentTask = 2
        TaskBriefings[1].state = "Completed"
        TaskBriefings[2].state = "Started"
        taskchange = true
        --RadioBroadcast("FARP")
      end
    elseif CurrentTask == 3 then
      -- position check
      BASE:I("Checking Berlin")
      local zone = ZONE:New("Pickup Berlin")
      local radius = zone:GetRadius()
      local coord = zone:GetCoordinate()
      local coord2 = Troops:GetCoordinate()
      local dist = coord:Get2DDistance(coord2)
      if dist <= radius then
        BASE:I("Activate Berlin")
        local Task1Sched = TIMER:New(ActivateFARP, "Berlin")
        Task1Sched:Start(farpactivetime)
        CurrentTask = 4
        TaskBriefings[3].state = "Completed"
        TaskBriefings[4].state = "Started"
        taskchange = true
        my_ctld:AddStockCrates("Humvee TOW",2)
        my_ctld:AddStockCrates("Humvee MG",2)
        my_ctld:AddStockCrates("Humvee JTAC",2)
        my_ctld:AddStockTroops("Mortar Squad (4)",2)
        my_ctld:AddStockTroops("Engineer Group (2)",1)
        my_ctld:AddStockTroops("Infantry Squad (6)",2)
        my_ctld:AddStockCrates("IFV Bradley",2)
        -- IFV Bradley
        my_ctld:AddStockTroops("Stinger Group (2)",2)
       -- RadioBroadcast("FARP")
       blueammotruck.homezone = zone
      end
    elseif CurrentTask == 4 then
      -- position check
      BASE:I("Checking Madrid")
      local zone = ZONE:New("Pickup Madrid")
      local radius = zone:GetRadius()
      local coord = zone:GetCoordinate()
      local coord2 = Troops:GetCoordinate()
      local dist = coord:Get2DDistance(coord2)
      if dist <= radius then
        BASE:I("Activate Madrid")
        local Task1Sched = TIMER:New(ActivateFARP, "Madrid")
        Task1Sched:Start(farpactivetime)
        CurrentTask = 5
        TaskBriefings[4].state = "Completed"
        TaskBriefings[5].state = "Started"
        taskchange = true
        my_ctld:AddStockCrates("Humvee TOW",4)
        my_ctld:AddStockCrates("Humvee MG",4)
        my_ctld:AddStockCrates("Humvee JTAC",4)
        my_ctld:AddStockCrates("IFV Bradley",4)
        my_ctld:AddStockTroops("Mortar Squad (4)",4)
        my_ctld:AddStockTroops("Engineer Group (2)",1)
        my_ctld:AddStockTroops("Infantry Squad (6)",8)
        --"Stinger Group (4)"
        my_ctld:AddStockTroops("Stinger Group (2)",8)
       -- RadioBroadcast("FARP")
       blueammotruck.homezone = zone
      end
    end
  elseif string.match(name,"Mortar") then
    local m  = MESSAGE:New(string.format("Mortar Squad %s in operation!",name),15,"Info"):ToAll()
      -- Get closest zone of type
    local outcome, name, zone, distance  = my_ctld:IsUnitInZone(Troops,CTLD.CargoZoneType.MOVE)
    if (distance <= 7000) and zone then
      local name = Troops:GetName()
      ArmyGroups[name] = ARMYGROUP:New(Troops)
      ArmyGroups[name]:SetVerbosity(4)
      -- local inzonegrps = zone:Scan(Object.Category.UNIT, {Unit.Category.GROUND_UNIT})
      --local inzoneset = zone:GetScannedSetUnit()
      local inzoneset = FindMortarTargets(Troops)
      --local no = inzoneset:CountAlive()
      --local grptable = inzoneset:GetSetObjects()
      --local n=1
      --local ammo = armygroup:GetAmmoTot()
      local rounds = 120
      --if rounds == 0 then rounds = 1 end
      --for _,_grp in pairs (grptable) do
      local _grp = inzoneset:GetRandom()
        if _grp and _grp:IsAlive() and _grp:GetCoalition() == coalition.side.RED then
          --BASE:I("Name: ".. _grp:GetName())
          local coord = _grp:GetCoordinate()
          ArmyGroups[name]:AddTaskFireAtPoint(coord,300,750,rounds)
          --n=n+1
        end
      --end
      --ArmyGroups[#ArmyGroups+1] = armygroup
    end
  end
  if taskchange == true then
    local m = MESSAGE:New("Briefing updated!",15,"Info"):ToBlue()
  end
end

function my_ctld:OnAfterCratesBuild(From,Event,To,Group,Unit,Vehicle)
  self:__Save(10)
  local vehicle = Vehicle -- Wrapper.Group#GROUP
  local vname = vehicle:GetName()
  -- do we have a JTAC?
  if string.match(vname,"JTAC") then
    --local code = codetable[math.random(#codetable)]
    --JTACAutoLase(vname, code, false,"all")
    local junit = vehicle:GetUnit(1)
    local junitname = junit:GetName()
    my_autolase:SetRecceLaserCode(junitname,1688)
    local m  = MESSAGE:New(string.format("JTAC %s in operation!",vname),15,"Info"):ToBlue()
  elseif string.match(vname,"LAV") then
    BASE:I("Routing LAV "..vname)
    local vcoord = vehicle:GetCoordinate()
    local w1zone = ZONE:New("Pickup Berlin")
    local w2zone = ZONE:New("Pickup Madrid")
    local w1coord = w1zone:GetCoordinate()
    local w2coord = w2zone:GetCoordinate()
    local dist1 = vcoord:Get2DDistance(w1coord)
    local dist2 = vcoord:Get2DDistance(w2coord)
    BASE:I(string.format("Routing LAV - dist1=%d, dist2=%d",dist1,dist2))
    local wpts = {}
    local wpt1 = vcoord:WaypointGround(30, "Off Road")
    local wpt2 = w1coord:WaypointGround(30,"On Road")
    local wpt3 = w2coord:WaypointGround(30,"On Road")
    local Route = {}
    --Route[#Route+1] = wpt1
    if dist1 > dist2 then
      Route[#Route+1] = wpt2
      Route[#Route+1] = wpt3
    else
      Route[#Route+1] = wpt3
      Route[#Route+1] = wpt2
    end
    vehicle:RoutePush(Route)
    vehicle:PatrolZones({w1zone,w2zone},30,"On Road",30,60)
    vehicle:OptionDisperseOnAttack(30)
  end
end

if EnableSaving then
  my_ctld:__Load(5)
end

-- activate FARP function
function ActivateFARP(name)
  BASE:I("Activate FARP " ..name)
  -- get actions
  local actions = StageActions[name] -- #table
  BASE:I({actions})
  local statics = actions.statics
  local groups = actions.groups
  local zones = actions.zones
  local message = actions.message -- #string
  local number = statics.number
  local name = statics.name
  local nexttask = actions.nexttask
  for i=1,number do
    local name = string.format("%s%d",name,i)
    local static = SPAWNSTATIC:NewFromStatic(name)
    static.InitDead = false
    static:Spawn()
  end
  
  for _,_group in pairs (groups) do
    local group = _group
    local number = group.number
    local name = group.name
    for i=1,number do
      local name = string.format("%s%d",name,i)
      local einheit = SPAWN:New(name)
        :Spawn()
    end
  end
  
  local zonename = zones.name
  my_ctld:ActivateZone(zonename,CTLD.CargoZoneType.LOAD)
  local m  = MESSAGE:New(message,15,"Info"):ToAll()
  RadioBroadcast("FARP")
  CurrentTask = nexttask
end

if EnableCSAR then
  local BlueCsar = CSAR:New("blue","Downed Pilot","SAR Wing")
  BlueCsar.coordtype = 1
  BlueCsar.verbose = 0
  BlueCsar.enableForAI = true
  BlueCsar.max_units = 0 -- no saves for unlisted helis
  BlueCsar.useprefix = true
  BlueCsar.csarPrefix = { "Gazelle", "Huey", "MI-8", "MI-24", "UH60"}
  BlueCsar.maxdownedpilots = 10
  BlueCsar.limitmaxdownedpilots = true
  BlueCsar.autosmoke = true
  BlueCsar.pilotmustopendoors = false
  BlueCsar.autosmokedistance = UTILS.NMToMeters(2)
  BlueCsar.immortalcrew = false
  BlueCsar:__Start(5)
end

BASE:I("CTLD Setup Ended")