BASE:I("Loading helper functions")

CurrentTask = 1

function RadioBroadcast(template)
  local soundz = {
    ["Air_Support"] = "Air support.ogg",
    ["Bandar"] = "Bandar taken.ogg",
    ["FARP"] = "FARP is back.ogg",
    ["Seerik"] = "Seerik captured.ogg",
    ["USMC"] = "USMC in Bandar.ogg",
    ["InsurgentsBandar"] = "InsurgentsBandar.ogg",
  }
  --local group, index = Spawn_Awacs:GetFirstAliveGroup()
  local static = STATIC:FindByName("Static Comms tower M-1",true)
  local sound = soundz[template]
  --local sound = "capitalists.ogg"
  --local unit = group:GetUnit(1)
  local Radio = static:GetRadio()

  Radio:SetFileName(sound)  -- We first need the file name of a sound,
  Radio:SetFrequency(271)   -- then a frequency in MHz,
  Radio:SetPower(250)
  Radio:SetModulation(radio.modulation.AM) -- and a modulation (we use DCS' enumeration, this way we don't have to type numbers).
  Radio:SetLoop(false)
  Radio:Broadcast() 
end

function AnnoyUsersWithText()
  local m=MESSAGE:New("Please use Frequency 271.000 AM for tactical communication when airborne!",10,"Info"):ToAll()
end

local annoytimer = TIMER:New(AnnoyUsersWithText)
annoytimer:Start(300,300)
  
-- leave some insurgents
local BandarZone1 = ZONE:New("Jask")
local BandarZone2 = ZONE:New("Jask 2")
local BandarZone3 = ZONE:New("Jask 3")

BandarInsurgents = {}

function adjustresistance(helipilots,planepilots,factor)
  BASE:I(string.format("*** Adjustresistance: Helis %d, Planes %d, Task %d",helipilots,planepilots,CurrentTask))
  
  if CurrentTask < 3 then
    if helipilots > 0 then
      for i=1,helipilots*factor do
       BandarInsurgents[#BandarInsurgents+1] = SPAWN
            :NewWithAlias("Bandar Insurgents","Bandar Insurgents-"..math.random(1,10000) )
            :InitRandomizeZones({BandarZone1,BandarZone2,BandarZone3})
            :InitRandomizeUnits(true,200,30)
            :InitDelayOff()
            :OnSpawnGroup(
              function (insurgents)
                insurgents:OptionAlarmStateRed()
                insurgents:OptionDisperseOnAttack(120)
              end
            )
            :Spawn()
      end
    elseif planepilots > 0 then
      local casset = SET_GROUP:New():FilterPrefixes("CAS Type"):FilterOnce()
      local casunit = casset:GetRandom()
      local homebase = AIRBASE:FindByName(AIRBASE.PersianGulf.Bandar_Abbas_Intl)
      if not casunit:IsAirPlane() then
        homebase = AIRBASE:FindByName("Red FARP Gorbi-1")
      end
      local redcas = SET_ZONE:New():FilterPrefixes("Red CAS 1"):FilterOnce()
      local flight = FLIGHTGROUP:New(casunit)
      flight:SetDespawnAfterLanding()
      flight:SetHomebase(AIRBASE:FindByName(homebase))
      flight:SetDetection(true)
      flight:SetEngageDetectedOn(5,nil,redcas,nil)
   
      local zonecas = ZONE:New("Red CAS 1")
      local mission = AUFTRAG:NewCAS(zonecas,2500)
      mission:SetTime(120,3600)
      mission:SetMissionAltitude(2500)
      flight:AddMission(mission)
      
      BandarInsurgents[#BandarInsurgents+1] = flight
    end
  elseif CurrentTask == 3 then
    if planepilots > 0 or helipilots > 0 then
      local casset = SET_GROUP:New():FilterPrefixes("CAS Type"):FilterOnce()
      local casunit = casset:GetRandom()
      local homebase = AIRBASE:FindByName(AIRBASE.PersianGulf.Bandar_Abbas_Intl)
      if not casunit:IsAirPlane() then
        homebase = AIRBASE:FindByName("Red FARP Gorbi-1")
      end
      local redcas = SET_ZONE:New():FilterPrefixes("Red CAS 2"):FilterOnce()
      local flight = FLIGHTGROUP:New(casunit)
      flight:SetDespawnAfterLanding()
      flight:SetHomebase(AIRBASE:FindByName(homebase))
      flight:SetDetection(true)
      flight:SetEngageDetectedOn(10,nil,redcas,nil)
   
      local zonecas = ZONE:New("Pickup Berlin")
      local mission = AUFTRAG:NewCAS(zonecas,2500)
      mission:SetTime(120,3600)
      mission:SetMissionAltitude(2500)
      flight:AddMission(mission)
      
      BandarInsurgents[#BandarInsurgents+1] = flight
    end
  elseif CurrentTask >= 4 then
    if planepilots > 0 or helipilots > 0 then
      for i=1,planepilots+helipilots do
        local casset = SET_GROUP:New():FilterPrefixes("CAS Type"):FilterOnce()
        local casunit = casset:GetRandom()
        local homebase = AIRBASE:FindByName(AIRBASE.PersianGulf.Bandar_Abbas_Intl)
        if not casunit:IsAirPlane() then
          homebase = AIRBASE:FindByName("Red FARP Gorbi-1")
        end
        local redcas = SET_ZONE:New():FilterPrefixes({"Red CAS 3","Defense","Move Seerik"}):FilterOnce()
        local flight = FLIGHTGROUP:New(casunit)
        flight:SetDespawnAfterLanding()
        flight:SetHomebase(AIRBASE:FindByName(homebase))
        flight:SetDetection(true)
        flight:SetEngageDetectedOn(15,nil,redcas,nil)
     
        local zonecas = ZONE:New("Pickup Madrid")
        local mission = AUFTRAG:NewCAS(zonecas,2500)
        mission:SetTime(120,3600)
        mission:SetMissionAltitude(2500)
        flight:AddMission(mission)
        
        BandarInsurgents[#BandarInsurgents+1] = flight
      end
    end  
  end  
end

helipilots = SET_CLIENT:New():FilterCoalitions("blue"):FilterActive():FilterCategories("helicopter"):FilterStart()
planepilots = SET_CLIENT:New():FilterCoalitions("blue"):FilterActive():FilterCategories("plane"):FilterStart()

function helipilots:OnEventPlayerEnterAircraft(EventData)
  --BASE:I({EventData})
  
  local eventdata = EventData -- Core.Event#EVENTDATA
  local group = eventdata.IniGroup
  local groupcoord = group:GetCoordinate()
  local name = eventdata.IniPlayerName
  --BASE:I("Spawned Player = " .. name)
  local task = CurrentTask
  local zonetbl = {
    [1] = "Move Bandar",
    [2] = "Pickup Berlin",
    [3] = "Pickup Madrid",
  }
  local function CheckZones(anfang,ende)
    local outcome = false
    while anfang <= ende do
      local zone = ZONE:New(zonetbl[anfang])
      local coord = zone:GetCoordinate()
      local dist = groupcoord:Get2DDistance(coord) or 400
       --BASE:I(string.format("Checking zone: %s; Distance = %d",zonetbl[anfang],dist))
      if dist < 2500 then outcome = true end
      anfang = anfang + 1
    end
    return outcome
  end
  if name then
    TaskReport(group)
    local outcome = false
    -- check location
    if task <= 2 then
      if CheckZones(1,3) then 
        group:Destroy(false,5)
        outcome = true 
      end    
    elseif task == 3 then
      if CheckZones(2,3) then 
        group:Destroy(false,5) 
        outcome = true 
      end
    elseif task == 4 then
      if CheckZones(3,3) then 
        group:Destroy(false,5)
        outcome = true 
      end
    end
    if outcome then
      local m = MESSAGE:New("Please select an aircraft in an already conquered zone!",20,"Info",true):ToGroup(group)
      groupcoord:Explosion(100,2)
    end
  end
end

helipilots:HandleEvent(EVENTS.PlayerEnterAircraft)

local nohelis0 = 0
local noplanes0 = 0

function CheckNoPilots()
  -- init
  local factor = 2 -- multiplyer
  local helichange = false
  local planechange = false
  local helidelta = 0
  local planedelta = 0
  -- count
  local nohelis = helipilots:CountAlive()
  local noplanes = planepilots:CountAlive()
  -- any changes?
  if nohelis > nohelis0 then
    helidelta = nohelis - nohelis0
    nohelis0 = nohelis
    helichange = true
  elseif noplanes > noplanes0 then
    planedelta = noplanes - noplanes0
    noplanes0 = noplanes
    planechange = true
  end
  BASE:I(string.format("*** Helis %d Delta %d",nohelis,helidelta))
  BASE:I(string.format("*** Planes %d Delta %d",noplanes,planedelta))
  -- adjust
  if (helichange or planechange) then
    if helidelta >= 1 then
      adjustresistance(helidelta,0,factor)
    elseif planedelta >=1 then
      adjustresistance(0,planedelta,factor)
    end
  end
end

local resistor = TIMER:New(CheckNoPilots)
resistor:Start(30,300)

BASE:I("Helper functions Done")