---
BASE:I("Loader helper functions")

local crateweight = 500
local soldierweight = 80
CurrentTask = 1
LoadedData = nil
BunnySaveOn = true

BunnyPath = SavePath
BunnyFile= "BunnyHop_Savegame.lua"
BunnySaveSpan = 300

-- SavePath = "C:\\Users\\post\\Saved Games\\DCS\\Missions\\Bunnyhop"
-- SavePath = "C:\\Users\\Administrator\\Saved Games\\DCS.openbeta_server_public_2\\persistent-data"

  local SeerikGroups = {
  "Red Ammo Seerik",
  "Red Ari Seerik",
  "Red SAM Seerik",
  "Red Samprotect Seerik",
  "Red Armor Seerik",
  "Red Ammo Seerik Town",
  "Red Armor Seerik-1",
  "Red SHORAD Seerik",
  --"Red SAM Bandar",
  --"Red Armor Bandar",
  --"Red SHORAD Bandar",
  --"Red Patrol Bandar",
  }


local BandarMainGroups={}

-- File IO
function BunnyLoad(path,filename)
    --- Function that check if a file exists.
  local function _fileexists(name)
     local f=io.open(name,"r")
     if f~=nil then
      io.close(f)
      return true
    else
      return false
    end
  end

  -- Check io module is available.
  if not io then
    BASE:E("WARNING: io not desanitized. Cannot load game state.")
    return false
  end

  -- Check default path.
  if path==nil and not lfs then
    BASE:E("WARNING: lfs not desanitized.")
    return false
  end

  -- Set path or default.
  if lfs then
    path=path or lfs.writedir()
  end

  -- Set file name.
  filename="BunnyHop_Savegame.lua"

  -- Set path.
  if path~=nil then
    filename=path.."\\"..filename
  end

  -- Check if file exists.
  local exists=_fileexists(filename)
  
    --- Function that load data from a file.
  local function _loadfile(filename)
    local f=assert(io.open(filename, "rb"))
    local data=f:read("*all")
    f:close()
    return data
  end

  -- Info message.
  local text=string.format("Loading Mission State from %s", filename)
  MESSAGE:New(text,10):ToAll()
  BASE:I(text)

  -- Load asset data from file.
  if exists then
    assert(loadfile(filename))()

    if LoadedData then
      -- BASE:I({LoadedData})
      for _,_entry in pairs (LoadedData) do
        local name = _entry.Group
        local vec3 = {}
        vec3.x = _entry.x
        vec3.y = _entry.y
        vec3.z = _entry.z
        local coord = COORDINATE:NewFromVec3(vec3)
        local alias = string.format("%s-%d", name, math.random(1,100000))
        my_ctld.TroopCounter = my_ctld.TroopCounter + 1
        my_ctld.DroppedTroops[my_ctld.TroopCounter] = SPAWN:NewWithAlias(name,alias)
          :InitRandomizeUnits(true,20,2)
          :InitDelayOff()
          :SpawnFromCoordinate(coord)
        my_ctld.TroopCounter = my_ctld.TroopCounter + 1  
      end
    end
    
  end
  
    -- Set file name.
  filename="BunnyHop_Seerik.lua"

  -- Set path.
  if path~=nil then
    filename=path.."\\"..filename
  end
  
  -- Check if file exists.
  local exists=_fileexists(filename)
  
  if exists then
  
    local file=assert(io.open(filename, "rb"))
    
    local loadeddata = {}
    for line in file:lines() do
      --self:I({line=type(line)})
        loadeddata[#loadeddata+1] = line
    end
    file:close()
    
    -- remove header
    table.remove(loadeddata, 1)
    
    
    for _,_line in pairs(loadeddata) do
      local dataset = UTILS.Split(_line,",")
      -- 1 = group name, 2 = size
      local name = dataset[1] or "none"
      local number = tonumber(dataset[2]) or 0
      local text = string.format("Loaded Name %s | Size %d",name,number)
      BASE:I(text)
      -- get actual size
      local actgroup = GROUP:FindByName(name)
      if actgroup and actgroup:IsAlive() then
        local actnumber = actgroup:CountAliveUnits()
        if actnumber > number then
          local reduction = actnumber-number
          BASE:I("Reducing groupsize by ".. reduction .. " units!")
          -- reduce existing group
          local units = actgroup:GetUnits()
          local units2 = UTILS.ShuffleTable(units) -- randomize table
          for i=1,reduction do
            units2[i]:Destroy(false)
          end
        end
      end    
    end
  
  end
end

function BandarLoad(path,filename)
    --- Function that check if a file exists.
  local function _fileexists(name)
     local f=io.open(name,"r")
     if f~=nil then
      io.close(f)
      return true
    else
      return false
    end
  end

  -- Check io module is available.
  if not io then
    BASE:E("WARNING: io not desanitized. Cannot load game state.")
    return false
  end

  -- Check default path.
  if path==nil and not lfs then
    BASE:E("WARNING: lfs not desanitized.")
    return false
  end

  -- Set path or default.
  if lfs then
    path=path or lfs.writedir()
  end

    -- Set file name.
  filename="BunnyHop_Bandar.lua"

  -- Set path.
  if path~=nil then
    filename=path.."\\"..filename
  end
  
  -- Check if file exists.
  local exists=_fileexists(filename)
  
  if exists then
  
    local file=assert(io.open(filename, "rb"))
    
    local loadeddata = {}
    for line in file:lines() do
      --self:I({line=type(line)})
        loadeddata[#loadeddata+1] = line
    end
    file:close()
    
    -- remove header
    table.remove(loadeddata, 1)
    
    local bandarset = SET_GROUP:New():FilterCategoryGround():FilterCoalitions("red"):FilterPrefixes("Bandar"):FilterOnce()
    
    local function FindInSet(name)
      local grp = nil
      local settable = bandarset:GetSetObjects()
      for _,_group in pairs(settable) do
        local group = _group -- Wrapper.Group#GROUP
        if group and group:IsAlive() then
          local gname = group:GetName()
          if string.match(gname,name) then
            grp = group
            break
          end
        end
      end
      return grp
    end
    
    for _,_line in pairs(loadeddata) do
      local dataset = UTILS.Split(_line,",")
      -- 1 = group name, 2 = size
      local name = dataset[1] or "none"
      name = string.gsub(name,"#(%d+)$","")
      local number = tonumber(dataset[2]) or 0
      local text = string.format("Loaded Name %s | Size %d",name,number)
      BASE:I(text)
      -- get actual size
      --local actgroup = GROUP:FindByName(name)
      local actgroup = FindInSet(name)
      if actgroup and actgroup:IsAlive() then
        local actnumber = actgroup:CountAliveUnits()
        if actnumber > number then
          local reduction = actnumber-number
          BASE:I("Reducing groupsize by ".. reduction .. " units!")
          -- reduce existing group
          local units = actgroup:GetUnits()
          local units2 = UTILS.ShuffleTable(units) -- randomize table
          for i=1,reduction do
            units2[i]:Destroy(false)
          end
        end
      end    
    end
  
  end
end

function BunnySave(path,filename)

  --- Function that saves data to file
  local function _savefile(filename, data)
    local f = assert(io.open(filename, "wb"))
    f:write(data)
    f:close()
  end

  -- Check io module is available.
  if not io then
    BASE:E("WARNING: io not desanitized. Cannot save game state.")
    return false
  end

  -- Check default path.
  if path==nil and not lfs then
    BASE:E("WARNING: lfs not desanitized.")
    return false
  end

  -- Set path or default.
  if lfs then
    path=path or lfs.writedir()
  end

  -- Set file name.
  filename=filename or "BunnyHop_Savegame.lua"

  -- Set path.
  if path~=nil then
    filename=path.."\\"..filename
  end
  
  --data = data .. string.format("CurrentTask = %d \n",CurrentTask)
  local data = string.format("CurrentTask = %d \n",CurrentTask)
  --BASE:I(data)
  
  _savefile(filename, data)
  
  -- Info message.
  local text=string.format("Saving Mission State to %s", filename)
  BASE:I(text) 
  --MESSAGE:New(text,10):ToAll()
  
  local data = "--Seerik Reds\n"
  for _,_group in pairs (SeerikGroups) do
    local group = GROUP:FindByName(_group) -- Wrapper.Group#GROUP
    if group and group:IsAlive() then
      local units = group:CountAliveUnits()
      data = string.format("%s%s, %d\n",data,_group,units)
    else
      data = string.format("%s%s, %d\n",data,_group,0)
    end
  end
  
  -- Set file name.
  filename="BunnyHop_Seerik.lua"

  -- Set path.
  if path~=nil then
    filename=path.."\\"..filename
  end
  
  BASE:I(data)
  
     -- Info message.
  local text=string.format("Saving Mission Seerik State to %s", filename)
  BASE:I(text)
  
  -- Bandar
  _savefile(filename, data)
  
    local data = "--Bandar Reds\n"
  for _,_group in pairs (BandarMainGroups) do
    --local group = GROUP:FindByName(_group) -- Wrapper.Group#GROUP
    local group = _group
    if group and group:IsAlive() then
      local units = group:CountAliveUnits()
      local name = group:GetName()
      data = string.format("%s%s, %d\n",data,name,units)
    else
      data = string.format("%s%s, %d\n",data,name,0)
    end
  end
  
  -- Set file name.
  filename="BunnyHop_Bandar.lua"

  -- Set path.
  if path~=nil then
    filename=path.."\\"..filename
  end
  
  BASE:I(data)
  
  _savefile(filename, data)
  
   -- Info message.
  local text=string.format("Saving Mission Bandar State to %s", filename)
  BASE:I(text)
end

-- act on Status
if BunnySaveOn then
  BunnyLoad(BunnyPath,BunnyFile)
end

BASE:I(string.format("Current Task is: %d",CurrentTask))

if CurrentTask > 5 then CurrentTask = 1 end

if CurrentTask == 1 then
  local InjectTroopsType = CTLD_CARGO:New(nil,"Injected Engineers",{"Engineers"},CTLD_CARGO.Enum.ENGINEERS,true,true,4,nil,false,80)
  local InjectZone = ZONE:New("Pickup Engin")
  my_ctld:InjectTroops(InjectZone,InjectTroopsType)
end

if CurrentTask <= 2 then
  local redsambandar = SPAWN:New("Red SAM Bandar")
    :OnSpawnGroup(
      function (group)
        BandarMainGroups[#BandarMainGroups+1] = group
      end
    )
    :Spawn()
  local redshoradbandar = SPAWN:New("Red SHORAD Bandar")
    :OnSpawnGroup(
      function (group)
        BandarMainGroups[#BandarMainGroups+1] = group
      end
      )
    :Spawn()
  
  local redarmorbandar = SPAWN:New("Red Armor Bandar")
    :OnSpawnGroup(
      function (group)
        BandarMainGroups[#BandarMainGroups+1] = group
      end
    )
    :Spawn()
  
  local redpatrol = SPAWN:New("Red Patrol Bandar")
    :InitLimit(2,3)
    :OnSpawnGroup(
      function (group)
        BandarMainGroups[#BandarMainGroups+1] = group
      end
    )
    :SpawnScheduled(600,0.5)
    
  -- act on Status
  if BunnySaveOn then
    bandartimer = TIMER:New(BandarLoad,BunnyPath,BunnyFile)
    bandartimer:Start(5)
  end 
end

function CheckMainBandar()
  local n=0
  for i=1,#BandarMainGroups do
    local grp = BandarMainGroups[i]
    if grp and grp:IsAlive() then
      n=n+1
      --grp:Destroy(false,20)
    end
  end
  if n == 0 then
    -- all dead
    -- retreat insurgents
    local retreat = false
    for _,_grp in pairs (BandarInsurgents) do
      local group = _grp --Wrapper.Group#GROUP
      if group and group:IsAlive() and group.ClassName == "GROUP" and group:IsGround() then
          group:Destroy(false,10)
          retreat = true
      end
    end
    if retreat then
      local m = MESSAGE:New("Well done! Looks the insurgents are retreating from Bandar e-Jask!",15,"Info"):ToBlue()
      RadioBroadcast("InsurgentsBandar")
      local intruder = SPAWN:New("Blue Intruder"):Spawn()
    end
  end
end

if CurrentTask > 1 then -- FARP Dallas
  TaskBriefings[1].state = "Completed"
  TaskBriefings[2].state = "Started"
  ActivateFARP("Dallas")      
end


if CurrentTask > 2 then -- AFB Bandar
  TaskBriefings[2].state = "Completed"
  TaskBriefings[3].state = "Started"
  my_ctld:AddCratesCargo("NASAMS Air Defence",{"NASAMS"},CTLD_CARGO.Enum.FOB,4,crateweight,4)
  my_ctld:AddCratesCargo("LAV-25 Patrol",{"IFC LAV Patrol"},CTLD_CARGO.Enum.FOB,2,crateweight,4)
  my_ctld:AddStockCrates("Humvee JTAC",2)
  my_ctld:AddStockCrates("IFV Bradley",2) 
  local intruder = SPAWN:New("Blue Intruder"):Spawn()
  local ship = SPAWN:New("Combattante"):Spawn()  
  local nasams = SPAWN:New("Blue SAM Bandar"):Spawn()
  local marines = SPAWN:New("USMC Bandar"):Spawn()
  my_ctld:AddStockTroops("Infantry Squad (6)",4)
  my_ctld:ActivateZone("Pickup Bandar",CTLD.CargoZoneType.LOAD)
  blueammotruck.homezone = ZONE:FindByName("Pickup Bandar")    
end

if CurrentTask > 3 then -- FARP Berlin
  TaskBriefings[3].state = "Completed"
  TaskBriefings[4].state = "Started"
  ActivateFARP("Berlin")
  my_ctld:AddStockCrates("Humvee TOW",2)
  my_ctld:AddStockCrates("Humvee MG",2)
  my_ctld:AddStockCrates("Humvee JTAC",2)
  my_ctld:AddStockTroops("Mortar Squad (4)",2)
  my_ctld:AddStockTroops("Engineer Group (2)",1)
  my_ctld:AddStockTroops("Infantry Squad (6)",2)
  my_ctld:AddStockCrates("IFV Bradley",2)
  blueammotruck.homezone = ZONE:FindByName("Pickup Berlin")      
end

if CurrentTask > 4 then -- FARP Madrid
  TaskBriefings[4].state = "Completed"
  TaskBriefings[5].state = "Started"
  ActivateFARP("Madrid")
  my_ctld:AddStockCrates("Humvee TOW",4)
  my_ctld:AddStockCrates("Humvee MG",4)
  my_ctld:AddStockCrates("Humvee JTAC",4)
  my_ctld:AddStockCrates("IFV Bradley",4)
  my_ctld:AddStockTroops("Mortar Squad (4)",4)
  my_ctld:AddStockTroops("Engineer Group (2)",1)
  my_ctld:AddStockTroops("Infantry Squad (6)",8)
  --"Stinger Group (4)"
  my_ctld:AddStockTroops("Stinger Group (2)",8)
   -- RadioBroadcast("FARP")
  --AirLiftGo()
  blueammotruck.homezone = ZONE:FindByName("Pickup Madrid")    
end

if BunnySaveOn then
  local BunnySaveTimer = TIMER:New(BunnySave,BunnyPath,BunnyFile)
  BunnySaveTimer:Start(BunnySaveSpan,BunnySaveSpan)
end

BASE:I("Loader functions done")
---
BASE:I("Tasks Setup Started")

local crateweight = 100
local soldierweight = 80

-- Task 2 -- Control if AFB is taken
function CheckBandar()
  local bandar = AIRBASE:FindByName(AIRBASE.PersianGulf.Bandar_e_Jask_airfield)
  --local bandar = AIRBASE:FindByName(AIRBASE.PersianGulf.Khasab)
  local coalition = bandar:GetCoalitionName()
  --BASE:I({Bandarcol = coalition})
  if coalition == "Blue" and CurrentTask == 2 then
    Task2Flag = true
    local m = MESSAGE:New("AFB Bandar e-Jask is blue! Well done!",15,"Info"):ToBlue()
    local m = MESSAGE:New("Briefing updated!",15,"Info"):ToBlue()
    local intruder = SPAWN:New("Blue Intruder"):Spawn()
    local ship = SPAWN:New("Combattante"):Spawn()
    BandarFlyInMarines()
    CurrentTask = 3
    TaskBriefings[2].state = "Completed"
    TaskBriefings[3].state = "Started"
    my_ctld:AddCratesCargo("NASAMS Air Defence",{"NASAMS"},CTLD_CARGO.Enum.FOB,4,crateweight,4)
    my_ctld:AddCratesCargo("LAV-25 Patrol",{"IFC LAV Patrol"},CTLD_CARGO.Enum.FOB,2,crateweight,4)
    my_ctld:ActivateZone("Pickup Bandar",CTLD.CargoZoneType.LOAD)
    my_ctld:AddStockCrates("IFV Bradley",2)
    blueammotruck.homezone = ZONE:FindByName("Pickup Bandar")
  else
    -- check if main red units in Bandar e_jask dare defeated
    CheckMainBandar()
  end
end

function BandarFlyInMarines()
  local transport = SPAWN:New("Transport USMC"):Spawn()
  transport:HandleEvent(EVENTS.Land)
  function transport:OnEventLand(EventData)
    local name = EventData.IniGroupName
    if string.find(name,"Transport USMC") then
      local nasams = SPAWN:New("Blue SAM Bandar"):Spawn()
      local marines = SPAWN:New("USMC Bandar"):Spawn()
      my_ctld:AddStockTroops("Infantry Squad (6)",4)      
      RadioBroadcast("USMC")
    end
  end
end

local BandarTimer = TIMER:New(CheckBandar)
BandarTimer:Start(30,30)

BASE:I("Tasks Setup Done")
--
