--
BASE:I("Menu Setup Started")
-- Flags
_SETTINGS:SetA2G_BR()
_SETTINGS:SetImperial()
_SETTINGS:SetMessageTime(MESSAGE.Type.Briefing,10)
_SETTINGS:SetMessageTime(MESSAGE.Type.Detailed,10)
_SETTINGS:SetMessageTime(MESSAGE.Type.Information,10)
_SETTINGS:SetMessageTime(MESSAGE.Type.Overview,10)
_SETTINGS:SetMessageTime(MESSAGE.Type.Update,10)
_SETTINGS:SetPlayerMenuOff()
--
-- Globals
local debug = true
--CurrentTask = 1

pilots = SET_CLIENT:New():FilterCoalitions("blue"):FilterActive():FilterStart()

TaskBriefings = {}

TaskBriefings[1] = {
  title = "Task: Repair FARP Dallas",
  brief = {
    "Pick up a group of Engineers near the ship south",
    "of here at the coast (Zone \'Engin\').",
    "Bring them to FARP Dallas, so they can repair the facility.",
    "Good Luck!",
  },
  state = "Started" --NotStarted,Started,Completed
}
TaskBriefings[2] = {
  title = "Task: Take AFB Bandar e-Jask",
  brief = {
    "Pick up a troops and vehicles from FARP Dallas.",
    "Drop them near drop zone \'Drop Bandar\'",
    "Engage and destroy the SA-6 site and any",
    "resistance you might find.",
    "Air CAP/CAS support is available via F10.",
    "USMC support will come in once done!",
    "Good Luck!",
  },
  state = "NotStarted" --NotStarted,Started,Completed
}
local berlin = ZONE:New("Pickup Berlin")
local berlinc = berlin:GetCoordinate()
local berlint = berlinc:ToStringLLDDM()
local berlintext = string.format("Coordinates: %s",berlint)
TaskBriefings[3] = {
  title = "Task: Activate FARP Berlin",
  brief = {
      "Pick up a group of Engineers from an active facility.",
      "Bring them to FARP Berlin, so they can repair the facility.",
      "Be aware of insurgent activity in the area.",
      berlintext,
      "Good Luck!",
  },
  state = "NotStarted" --NotStarted,Started,Completed
}
local madrid = ZONE:New("Pickup Madrid")
local madridc = madrid:GetCoordinate()
local madridt = madridc:ToStringLLDDM()
local madridtext = string.format("Coordinates: %s",madridt)
TaskBriefings[4] = {
  title = "Task: Repair FARP Madrid",
  brief = {
    "Pick up a group of Engineers from an active facility.",
    "Bring them to FARP Madrid, so they can repair the facility.",
    "Be aware of insurgent activity in the area.",
    madridtext,
    "Good Luck!",
  },
  state = "NotStarted" --NotStarted,Started,Completed
}
TaskBriefings[5] = {
  title = "Task: Endgame - Seerik",
  brief = {
    "Take the insurgent stronghold of Seerik.",
    "Good Luck!",
  },
  state = "NotStarted" --NotStarted,Started,Completed
}
TaskBriefings[6] = {
  title = "Task: End of Blockade",
  brief = {
    "Good job! you won, all tasks completed!",
  },
  state = "NotStarted" --NotStarted,Started,Completed
}
-- Task report
function TaskReport(Group)
  -- give Player Task reports
  local report = REPORT:New("Operation Bunnyhop")
  local title = TaskBriefings[CurrentTask].title
  local state = TaskBriefings[CurrentTask].state
  local brief = TaskBriefings[CurrentTask].brief -- #table
  report:AddIndent(title,"#")
  report:AddIndent("------------------","#")
  for _,_entry in pairs(brief) do
    report:AddIndent(_entry,"#")
  end
  report:AddIndent("------------------","#")
  report:AddIndent(string.format("Status: %s",state),"#")
  local m = MESSAGE:New(report:Text(),45,"Info"):ToGroup(Group)
end

EscortGroup = {}
AuftragList = {}
function TaskEscort(Group)
  local group = Group -- Wrapper.Group#GROUP
  local name = group:GetName()
  local clientu = group:GetUnit(1)
  local cname = clientu:GetName()
  local client = CLIENT:FindByName(cname)
  local alive = false
  if EscortGroup[name] then
    local escortgrp = EscortGroup[name] -- Wrapper.Group#GROUP
    if not escortgrp:IsAlive() then
      alive = false
      EscortGroup[name] = nil
    else
      alive = true
      local m = MESSAGE:New("You already have an escort group!",15,"Info"):ToGroup(Group)
      return
    end
  end
  if not alive then
    local coordinate = group:GetCoordinate()
    local coord = coordinate:GetRandomCoordinateInRadius(500,100)
    coord.y = 500
    EscortGroup[name] = SPAWN:NewWithAlias("Escort",string.format("Escort-%s-%d",name,math.random(1,1000)))
    :InitDelayOff()
    :InitRadioFrequency(271)
    :OnSpawnGroup(
      function(grp)
        local flight = FLIGHTGROUP:New(grp)
        --local escort = ESCORT:New(client,grp,"Angel","We'll watch over you.")
        local auftrag = AUFTRAG:NewESCORT(Group,nil,5,{"Ground","Air"})
        auftrag:SetRadio(271,0)
        auftrag:SetTime(180,3600)
        --auftrag:SetVerbosity(0)
        AuftragList[name] = auftrag
        flight:AddMission(auftrag)
        local m = MESSAGE:New("Escort group will follow you 1hr!",15,"Info"):ToGroup(Group)
      end
    )
    :SpawnFromPointVec3(coord)
  end
end

function SetMenus()
  local pilottable = pilots:GetSetObjects()
  for _,_unit in pairs (pilottable) do
    local Unit = _unit -- Wrapper.Unit#UNIT
    if Unit and Unit:IsAlive() then
      local Group = Unit:GetGroup()
      local MenuBunny = MENU_GROUP_COMMAND:New(Group,"Bunnyhop Active Task",nil,TaskReport,Group)
      local MenuEscort = MENU_GROUP_COMMAND:New(Group,"Request Escort Heli",nil,TaskEscort,Group)
      MenuBunny:Refresh()
    end
  end
end

local mentimer = TIMER:New(SetMenus)
mentimer:Start(1,30)

BASE:I("Menu Setup Done")