--- Bunnyhop Red SAMs

BASE:I("Red SAM Setup Started")

local testari = true
AIRBASE:FindByName(AIRBASE.PersianGulf.Bandar_Abbas_Intl):SetParkingSpotBlacklist({38,39,40,41,42,43,44,45,46,47,48,49,50,51})

local redawacs = SPAWN:New("Red EWR Awacs")
  :InitLimit(1,0)
  :InitDelayOff()
  :InitCleanUp(30)
  :SpawnScheduled(30,0.5)

-- Speedboat Patrol
local IranPatrolSet = SET_ZONE:New():FilterPrefixes("Iran Patrol Zone"):FilterOnce()
local PatrolZones = IranPatrolSet:GetSetObjects()
IranPatrol = SPAWN:New("Iran Speedboat")
  :InitLimit(6,1)
  :InitDelayOff()
  :OnSpawnGroup(
    function (grp)
      grp:PatrolZones(PatrolZones,40,"Vee",10,60)
    end
  )
  :SpawnScheduled(300,0.5)

local redmantis = MANTIS:New("Red Hell","Red SAM BAI","Red EWR",nil,"red",true,"Red EWR Awacs",false,10)
redmantis:__Start(2)
redmantis:SetEWRRange(125000)
redmantis:SetSAMRadius(35000)

local redsambsead = SEAD:New("Red SAM",10)
redsambsead:SetEngagementRange(70)

-- GCI
local Rus_DetectionSetGroup = SET_GROUP:New():FilterPrefixes( { "Red EWR"} ):FilterStart()

local Rus_Detection = DETECTION_AREAS:New( Rus_DetectionSetGroup, 30000 ):FilterCategories(Unit.Category.AIRPLANE)

-- Setup the A2A dispatcher, and initialize it.
local Rus_A2ADispatcher = AI_A2A_DISPATCHER:New( Rus_Detection )

-- Any enemy crossing this border will be engaged.
local Rus_BorderZone = ZONE_POLYGON:New( "Rus Border", GROUP:FindByName( "Red Border" ) )
Rus_A2ADispatcher:SetBorderZone( Rus_BorderZone )

Rus_A2ADispatcher:SetTacticalDisplay( false )

Rus_A2ADispatcher:SetDefaultCapLimit(2)
Rus_A2ADispatcher:SetDefaultFuelThreshold(0.3)
Rus_A2ADispatcher:SetDefaultLandingAtEngineShutdown()
Rus_A2ADispatcher:SetDefaultTakeoffFromParkingCold()

Rus_A2ADispatcher:SetSquadron("Red Hell CAP",AIRBASE.PersianGulf.Bandar_Abbas_Intl,{"Red CAP 1-1","Red CAP 1-2","Red CAP 1-3"})
Rus_A2ADispatcher:SetSquadron("Red Hell GCI",AIRBASE.PersianGulf.Bandar_Abbas_Intl,{"Red CAP 1-1","Red CAP 1-2","Red CAP 1-3"})

local capzone = ZONE:New("Red CAP")
local capcoord = capzone:GetCoordinate()
Rus_A2ADispatcher:SetSquadronGci("Red Hell GCI",1200,2000)
Rus_A2ADispatcher:SetSquadronCap("Red Hell CAP",capzone,UTILS.FeetToMeters(15000), UTILS.FeetToMeters(30000) , UTILS.KnotsToKmph(300),UTILS.KnotsToKmph(400), UTILS.KnotsToKmph(600), UTILS.KnotsToKmph(800), "BARO")
Rus_A2ADispatcher:SetSquadronCapRacetrack("Red Hell CAP",10,30,70,250,nil,nil,capcoord)

Rus_A2ADispatcher:SetIntercept( 180 )
Rus_A2ADispatcher:SetDisengageRadius(100000)
Rus_A2ADispatcher:SetEngageRadius( 55000 )
Rus_A2ADispatcher:SetGciRadius( 125000 )
Rus_A2ADispatcher:SetDefaultOverhead( 0.5 ) --avoid Mig-Wall
-- Get going
Rus_A2ADispatcher:Start()

-- leave some insurgents
local BerlinInsurgents = SPAWN
    :New( "Berlin Insurgents" )
    :InitLimit( 10,0 )
    :InitRandomizeUnits(true,5000,300)
    :InitDelayOff()
    :OnSpawnGroup(
      function (insurgents)
        insurgents:SetOption(8,120) --disperse under fire
      end
    )
    :Spawn()

-- leave some insurgents
local MadridInsurgents = SPAWN
    :New( "Madrid Insurgents" )
    :InitLimit( 10,0 )
    :InitRandomizeUnits(true,5000,300)
    :InitDelayOff()
    :OnSpawnGroup(
      function (insurgents)
        insurgents:SetOption(8,120) --disperse under fire
      end
    )
    :Spawn()
    
-- leave some insurgents
local SeerikInsurgents = SPAWN
    :New( "SeerikInsurgents" )
    :InitLimit( 10,5 )
    :InitRandomizeUnits(true,1000,50)
    --:InitRandomizePosition(true,1000,50)
    :InitDelayOff()
    :OnSpawnGroup(
      function (insurgents)
        insurgents:SetOption(8,120) --disperse under fire
        insurgents:OptionAlarmStateRed()
      end
    )
    :SpawnScheduled(60,0.5)

local ZonePosition = ZONE_GROUP:New( "Position", GROUP:FindByName("Red SAM Seerik"), 400 )

local SpawnTetra = SPAWNSTATIC:NewFromStatic( "Tetrapod", country.id.RUSSIA )
local SpawnFShape = SPAWNSTATIC:NewFromStatic( "F-Shape", country.id.RUSSIA )

local ZonePointVec2 = ZonePosition:GetPointVec2()

--local Building = SpawnBuilding:SpawnFromZone( ZonePosition, 0 )

for Heading = 0,360,3 do
  local Radial = Heading * ( math.pi*2 ) / 360
  local x = ZonePointVec2:GetLat() + math.cos( Radial ) * 310
  local y = ZonePointVec2:GetLon() + math.sin( Radial ) * 310
  SpawnFShape:SpawnFromPointVec2( POINT_VEC2:New( x, y ), Heading + 90 )
end

for Heading = 0,360,2 do
  local Radial = Heading * ( math.pi*2 ) / 360
  local x = ZonePointVec2:GetLat() + math.cos( Radial ) * 330
  local y = ZonePointVec2:GetLon() + math.sin( Radial ) * 330
  SpawnTetra:SpawnFromPointVec2( POINT_VEC2:New( x, y ), Heading + 90 )
end

-- Seerik zone
CaptureZone = ZONE:New("Move Seerik")

ZoneCaptureCoalition = ZONE_CAPTURE_COALITION:New(CaptureZone, coalition.side.RED, {Unit.Category.HELICOPTER, Unit.Category.GROUND_UNIT})

function ZoneCaptureCoalition:OnEnterCaptured()
  local Coalition = self:GetCoalition()
  if Coalition == coalition.side.BLUE then
    local m = MESSAGE:New(string.format( "We captured Seerik! Excellent job! Blockade is broken!" ),15, "Info"):ToAll()
    RadioBroadcast("Seerik")
    IranPatrol:SpawnScheduleStop()
    local patrol = IranPatrol:GetFirstAliveGroup() -- Wrapper.Group#GROUP
    local patrolunits = patrol:GetUnits()
    for _,_ship in pairs(patrolunits) do
      local patrolloc = _ship:GetCoordinate()
      patrolloc:Explosion(200,1)
      _ship:Destroy()
    end
    local redsam = GROUP:FindByName("Red SAM Seerik")
    local redsam2 = GROUP:FindByName("Red Samprotect Seerik")
    local redcoord = redsam:GetCoordinate()
    local redcoord2 = redsam2:GetCoordinate()
    redcoord:Explosion(10000,1)
    redcoord2:Explosion(10000,1)
    CurrentTask = 6
    TaskBriefings[5].state = "Completed"
    TaskBriefings[6].state = "Completed"
    RadioBroadcast("Seerik")
  else
    local m = MESSAGE:New(string.format( "We need to take Seerik! Go ahead!" ),15, "Info"):ToBlue()
  end
  self:__Guard( 5 )
end

local SeerikFlights = {}
local RedAriSeerik = ARMYGROUP:New("Red Ari Seerik")
--RedAriSeerik:SetVerbosity(5)
local RedTargetZones = SET_ZONE:New():FilterPrefixes("Defense"):FilterOnce()


function ZoneCaptureCoalition:OnAfterAttack(From,Event,To)
  local Coalition = self:GetCoalition()
  if Coalition == coalition.side.RED then
    local casset = SET_GROUP:New():FilterPrefixes("CAS Type"):FilterOnce()
    local casunit = casset:GetRandom()
    local homebase = AIRBASE:FindByName(AIRBASE.PersianGulf.Bandar_Abbas_Intl)
    if not casunit:IsAirPlane() then
      homebase = AIRBASE:FindByName("Red FARP Gorbi-1")
    end
    local redcas = SET_ZONE:New():FilterPrefixes({"Move Seerik","Defense"}):FilterOnce()
    local flight = FLIGHTGROUP:New(casunit)
    flight:SetDespawnAfterLanding()
    flight:SetHomebase(AIRBASE:FindByName(homebase))
    flight:SetDetection(true)
    flight:SetEngageDetectedOn(10,nil,redcas,nil)
 
    local zonecas = ZONE:New("Move Seerik")
    local mission = AUFTRAG:NewCAS(zonecas,2500)
    mission:SetTime(120,1800)
    mission:SetMissionAltitude(2500)
    flight:AddMission(mission)
    
    SeerikFlights[#SeerikFlights+1] = flight
    
    -- Artillery
    local redtargets = RedTargetZones:GetSetObjects()
    for _,_zone in pairs (redtargets) do
      local coord = _zone:GetCoordinate()
      RedAriSeerik:AddTaskFireAtPoint(coord,60,500,20)
    end
  end
end

ZoneCaptureCoalition:SetMonitorHits(true,15*60)
ZoneCaptureCoalition:Start( 5, 60 )
--ZoneCaptureCoalition:__Guard( 6 )

local redrat = RAT:New("Red Transport","Red Transport I")
redrat:SetDeparture({AIRBASE.PersianGulf.Qeshm_Island,AIRBASE.PersianGulf.Bandar_Lengeh})
redrat:SetDestination({AIRBASE.PersianGulf.Havadarya,AIRBASE.PersianGulf.Bandar_Abbas_Intl,AIRBASE.PersianGulf.Jiroft_Airport})
redrat:Commute(true)
redrat:ATC_Messages(false)
redrat:Spawn(1)

local redrat1 = RAT:New("Red Transport 2","Red Transport II")
redrat1:SetDestination({AIRBASE.PersianGulf.Qeshm_Island,AIRBASE.PersianGulf.Bandar_Lengeh})
redrat1:SetDeparture({AIRBASE.PersianGulf.Havadarya,AIRBASE.PersianGulf.Bandar_Abbas_Intl,AIRBASE.PersianGulf.Jiroft_Airport})
redrat1:Commute(true)
redrat1:ATC_Messages(false)
redrat1:Spawn(1)

BASE:I("Red SAM Setup Done")