---
BASE:I("Trucklift Starting")

function TruckLiftGo()

  local SetCargoInfantry = SET_CARGO:New():FilterTypes( "Infantry" ):FilterStart()
  local SetAPC = SET_GROUP:New():FilterPrefixes( "APC Group" ):FilterStart()
  local SetPickupZones = SET_ZONE:New():FilterPrefixes( "Pickup Location" ):FilterStart()
  local SetDeployZones = SET_ZONE:New():FilterPrefixes( "Defense" ):FilterStart()
  
  AICargoDispatcherAPC= AI_CARGO_DISPATCHER_APC:New( SetAPC, SetCargoInfantry, SetPickupZones, SetDeployZones, 500 ) 
  AICargoDispatcherAPC:SetHomeZone( ZONE:FindByName( "Home" ) )
  
  -- Now we create 4 zones based on GROUP objects within the battlefield, which form the front line defense points.
  local ZoneDefense1 = ZONE:New( "Defense 1" )
  local ZoneDefense2 = ZONE:New( "Defense 2" )
  local ZoneDefense3 = ZONE:New( "Defense 3" )
  local ZoneDefense4 = ZONE:New( "Defense 4" )
  
  function AICargoDispatcherAPC:OnAfterUnloaded(From,Event,To,CarrierGroup,Cargo,CarrierUnit,DeployZone)
    local cargo = Cargo -- Cargo.Cargo#CARGO
    local Group = cargo:GetObject() -- Wrapper.Group#GROUP
    local zone = ZONE:New("Move Seerik")
    local coord = zone:GetRandomCoordinate()
    Group:RouteGroundTo(coord,30,"Vee",5)
  end
  
  AICargoDispatcherAPC:SetPickupRadius( 75, 25)
  AICargoDispatcherAPC:SetDeployRadius( 200, 100 )
  AICargoDispatcherAPC:SetPickupSpeed( 50, 30 )
  AICargoDispatcherAPC:SetDeploySpeed( 50, 30 )
  
  AICargoDispatcherAPC:__Start( 10 )
  
end

local helipilottrucks = SET_CLIENT:New():FilterCoalitions("blue"):FilterActive():FilterCategories("helicopter"):FilterStart()
local trooplifton = false

local SpawnCargoInfantry={}
function CheckTruckLift()
  local alivecount = helipilottrucks:CountAlive()
  if CurrentTask > 4 and alivecount > 0 and not trooplifton then
    TruckLiftGo()
    trooplifton = true
      -- Here we setup the spawning of Infantry.
    SpawnCargoInfantry[#SpawnCargoInfantry+1] = SPAWN
      :NewWithAlias( "Infantry", "Infantry-"..math.random(1,10000))    
      :InitLimit( 40, 5 )
      :InitRandomizeZones( { ZONE:New( "Pickup Location" )} )
      :OnSpawnGroup(
        function( SpawnGroup )
          -- This will automatically add also the CargoInfantry object to the SetCargoInfantry (in the background through the event system).
          local CargoInfantry = CARGO_GROUP:New( SpawnGroup, "Infantry", SpawnGroup:GetName(), 1000 )
        end
      )
      :SpawnScheduled( 60, 0.5 )
      
    SpawnCargoInfantry[#SpawnCargoInfantry+1] = SPAWN
      :NewWithAlias("APC Group","APC Group"..math.random(1,10000))
      :InitLimit(2,8)
      :InitDelayOff()
      :SpawnScheduled(60,0.5)
    
    BASE:I("**** Trucklift ON")
  elseif CurrentTask > 4 and alivecount == 0 and trooplifton then
    AICargoDispatcherAPC:__Stop(1)
    trooplifton = false
    BASE:I("**** Trucklift OFF")
  end
  return
end

local CheckTruckTimer = TIMER:New(CheckTruckLift)
CheckTruckTimer:Start(30,60)

BASE:I("Trucklift Ended")